VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsICL"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

' ++ API Declarations ++
  Private Declare Function ReadFile Lib "kernel32" (ByVal hFile As Long, ByVal lpBuffer As Long, ByVal nNumberOfBytesToRead As Long, lpNumberOfBytesRead As Long, ByVal lpOverlapped As Long) As Long
  Private Declare Function FlushFileBuffers Lib "kernel32" (ByVal hFile As Long) As Long
  Private Declare Function SetFilePointer Lib "kernel32" (ByVal hFile As Long, ByVal lDistanceToMove As Long, lpDistanceToMoveHigh As Long, ByVal dwMoveMethod As FileOffsetTypes) As Long
  Private Declare Function CloseHandle Lib "kernel32" (ByVal hObject As Long) As Long
  Private Declare Function CreateFile Lib "kernel32.dll" Alias "CreateFileA" (ByVal lpFileName As String, ByVal dwDesiredAccess As Long, ByVal dwShareMode As Long, lpSecurityAttributes As Any, ByVal dwCreationDisposition As Long, ByVal dwFlagsAndAttributes As Long, ByVal hTemplateFile As Long) As Long
  Private Declare Function OleCreatePictureIndirect Lib "olepro32.dll" (lpPictDesc As PictDesc, riid As Guid, ByVal fPictureOwnsHandle As Long, ipic As IPicture) As Long
  Private Declare Function CreateIconIndirect Lib "user32" (piconinfo As ICONINFO) As Long
  Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (lpvDest As Any, lpvSource As Any, ByVal cbCopy As Long)
  Private Declare Function SelectObject Lib "gdi32" (ByVal hDC As Long, ByVal hObject As Long) As Long
  Private Declare Function DeleteDC Lib "gdi32" (ByVal hDC As Long) As Long
  Private Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long
  Private Declare Function CreateCompatibleDC Lib "gdi32" (ByVal hDC As Long) As Long
  Private Declare Function CreateCompatibleBitmap Lib "gdi32" (ByVal hDC As Long, ByVal nWidth As Long, ByVal nHeight As Long) As Long
  Private Declare Function CreateBitmap Lib "gdi32" (ByVal nWidth As Long, ByVal nHeight As Long, ByVal nPlanes As Long, ByVal nBitCount As Long, lpBits As Any) As Long
  Private Declare Function BitBlt Lib "gdi32" (ByVal hDestDC As Long, ByVal X As Long, ByVal Y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal dwRop As Long) As Long
  Private Declare Function StretchBlt Lib "gdi32" (ByVal hDC As Long, ByVal X As Long, ByVal Y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal nSrcWidth As Long, ByVal nSrcHeight As Long, ByVal dwRop As Long) As Long
  Private Declare Function SetDIBitsToDevice Lib "gdi32" (ByVal hDC As Long, ByVal X As Long, ByVal Y As Long, ByVal dx As Long, ByVal dy As Long, ByVal SrcX As Long, ByVal SrcY As Long, ByVal Scan As Long, ByVal NumScans As Long, Bits As Any, BitsInfo As Any, ByVal wUsage As Long) As Long

' ========================================================

' Modulbasisname
  Private Const cstrMODULEBASENAME As String = ".ICL."

' Pfad vom ICL-Datei
  Private strFileName As String

' Internes Modulebene Variable
  Private icdIconData() As IconData

' Anzahl der Icons im ICL-Datei
  Private lngIconCount As Long
  
' Farbinformationen
  Private Const DIB_RGB_COLORS As Long = 0

' Resource idTypes
  Private Const IMAGE_ICON As Long = 1

' Bitmap-Kompression types
  Private Const BI_RGB As Long = 0&

' Bitmap-Kopfsprunggre
  Private Const BITMAP_HEADER_SIZE    As Long = 40

' Konstanten
  Private Const RT_ICON                 As Long = &H3
  Private Const RT_GROUP_ICON           As Long = &HE
  Private Const RT_HIGHORDER            As Long = &H8000&
  Private Const GENERIC_READ            As Long = &H80000000
  Private Const GENERIC_WRITE           As Long = &H40000000
  Private Const FILE_SHARE_READ         As Long = &H1
  Private Const CREATE_ALWAYS           As Long = 2
  Private Const OPEN_ALWAYS             As Long = 4
  Private Const OPEN_EXISTING           As Long = 3
  Private Const TRUNCATE_EXISTING       As Long = 5
  Private Const FILE_ATTRIBUTE_ARCHIVE  As Long = &H20

' ========================================================

' ++ Type ++
  Private Type Guid
    Data1 As Long
    Data2 As Integer
    Data3 As Integer
    Data4(0 To 7) As Byte
  End Type

  Private Type ICONINFO
    fIcon As Long
    xHotspot As Long
    yHotspot As Long
    hBmMask As Long
    hbmColor As Long
  End Type

  Private Type PictDesc
    cbSizeofStruct As Long
    picType As Long
    hImage As Long
    xExt As Long
    yExt As Long
  End Type

  Private Type IMAGE_DOS_HEADER
    e_magic As Integer      ' Magische Zahl
    e_cblp As Integer       ' Bytes an der letze Seite vom Datei
    e_cp As Integer         ' Seiten in Datei
    e_crlc As Integer       ' Relocations
    e_cparhdr As Integer    ' Gre des Kopfsprungs in Abstzen
    e_minalloc As Integer   ' Erforderliche Minimalzustzliche Abstze
    e_maxalloc As Integer   ' Erforderliche Maximalzustzliche Abstze
    e_ss As Integer         ' Anfang (relativen) SS Wert
    e_sp As Integer         ' Anfang SP Wert
    e_csum As Integer       ' Kontrollsumme
    e_ip As Integer         ' Anfang IP Wert
    e_cs As Integer         ' Anfang (relativen) CS Wert
    e_lfarlc As Integer     ' Datei Adresse der Standortwechseltabelle
    e_ovno As Integer       ' Belegte Nummer
    e_res(0 To 3) As Integer ' Reservierte Wrter
    e_oemid As Integer      ' OEM Kennzeichnung (fr e_oeminfo)
    e_oeminfo As Integer    ' OEM Information; e_oemid Einzelheit
    e_res2(0 To 9) As Integer ' Reservierte Wrter
    e_lfanew As Long        ' Datei Adresse des neuen EXE Kopfsprungs
  End Type

  Private Type IMAGE_WINDOWS_NE_HEADER
    Machine As Integer
    LinkerVersion As Byte
    LinkerRevision As Byte
    EntryOffset As Integer
    EntryLength As Integer
    Reserved1 As Long
    Flags As Integer
    SegNumber As Integer
    InitialHeapSize As Integer
    InitialStackSize As Integer
    SegOffsetCSIP As Long
    SegOffsetSSSP As Long
    SegmentTableCount As Integer
    ModRefTableCount As Integer
    NonResidentNameSize As Integer
    SegmentTableOffset As Integer
    ResourceTableOffset As Integer
    ResidentNameTableOffset As Integer
    ModuleRefTableOffset As Integer
    ImportedNameTableOffset As Integer
    NonResidentNameTableOffset As Long
    MovableEntryPointCount As Integer
    ShiftCount As Integer
    ResourceSegmentCount As Integer
    TargetOS As Byte
    OSAddlInfo As Byte
    FastLoadOffset As Integer
    FastLoadLength As Integer
    Reserved2 As Integer
    WindowsVersion As Integer
  End Type

  Private Type TNAMEINFO
    rnOffset As Integer
    rnLength As Integer
    rnFlags As Integer
    rnID As Integer
    rnHandle As Integer
    rnUsage As Integer
  End Type

  Private Type IconEntry
    Width As Byte
    Height As Byte
    NumColors As Byte
    Reserved As Byte
    NumPlanes As Integer
    BitsPerPixel As Integer
    DataSize As Long
    DataOffset As Long
   End Type

  Private Type ICONDIR
    idReserved As Integer       ' Reserviert
    idType As Integer           ' Ressourcenart (1 fr Icon)
    idCount As Integer          ' Anzahl der Bilder
  End Type

  Private Type BITMAPINFOHEADER ' 40 Bytes
   biSize As Long
   biWidth As Long
   biHeight As Long
   biPlanes As Integer
   biBitCount As Integer
   biCompression As Long
   biSizeImage As Long
   biXPelsPerMeter As Long
   biYPelsPerMeter As Long
   biClrUsed As Long
   biClrImportant As Long
  End Type

  Private Type RGBQUAD
    rgbBlue As Byte
    rgbGreen As Byte
    rgbRed As Byte
    rgbReserved As Byte
  End Type

  Private Type MEMICONDIRENTRY
    bWidth As Byte               ' Breite des Bildes
    bHeight As Byte              ' Hhe des Bildes (2 Mal)
    bColorCount As Byte          ' Anzahl von Farben in Abbildung (0 if >=8bpp)
    bReserved As Byte            ' Reserviert
    wPlanes As Integer           ' Color Planes
    wBitCount As Integer         ' Bits pro pixel
    dwBytesInRes As Long         ' Anzahl der Bytes in diesem Resource
    nID As Integer               ' ID
  End Type

' Benutzerdefinierte UDTs
  Private Type IconGroupData
    DirHeader As ICONDIR
    Entries() As MEMICONDIRENTRY
  End Type

  Private Type IconBitmapData
    Header As BITMAPINFOHEADER
    Palette() As RGBQUAD
    XORMap() As Byte
    ANDMap() As Byte
  End Type

  Private Type IconData
    Name As String
    Group As IconGroupData
    Bitmaps() As IconBitmapData
  End Type

  Private Type DataOffsetLength
    offset As Long
    Length As Long
  End Type

  Private Type BITMAPINFO_1BPP
   bmiHeader As BITMAPINFOHEADER
   bmiColors(0 To 1) As RGBQUAD
  End Type

  Private Type BITMAPINFO_8BPP
   bmiHeader As BITMAPINFOHEADER
   bmiColors(0 To 255) As RGBQUAD
  End Type

' ========================================================

' ++ Enum ++
  Private Enum FileOffsetTypes
    FILE_BEGIN = 0&
    FILE_CURRENT = 1&
    FILE_END = 2&
  End Enum

  Private Enum OpenMode
    ForReading = 0
    ForWriting = 1
  End Enum

  Private Enum ECFIImageConstants
   ecfiImage = 0
   ecfiMask = 1
  End Enum

' ========================================================

' ++ Property ++

' Pfad der ICL-Datei
  Public Property Get Filename() As String
    Filename = strFileName
  End Property
  Public Property Let Filename(ByVal Value As String)
    strFileName = Value
  End Property

' Anzahl der Icons in der ICL-Datei
  Public Property Get IconCount() As Long
    IconCount = lngIconCount
  End Property
  
' Anzahl der Bilder in der ICL-Datei
  Public Property Get ImageCount(ByVal Index As Long) As Long
    ImageCount = icdIconData(Index - 1).Group.DirHeader.idCount
  End Property

' Breite des Icons
  Public Property Get ImageWidth(ByVal IconIndex As Long, ByVal ImageIndex As Long) As Long
    ImageWidth = icdIconData(IconIndex - 1).Bitmaps(ImageIndex - 1).Header.biWidth
  End Property

' Lnge des Icons
  Public Property Get ImageHeight(ByVal IconIndex As Long, ByVal ImageIndex As Long) As Long
    ImageHeight = icdIconData(IconIndex - 1).Bitmaps(ImageIndex - 1).Header.biHeight \ 2
  End Property

' Farbtiefe des Icons
  Public Property Get ColorDepth(ByVal IconIndex As Long, ByVal ImageIndex As Long) As Long
    ColorDepth = icdIconData(IconIndex - 1).Bitmaps(ImageIndex - 1).Header.biBitCount
  End Property

' Name des Icons
  Public Property Get IconName(ByVal IconIndex As Long) As String
    IconName = icdIconData(IconIndex - 1).Name
  End Property

'ndern des Icons in einenn VB StdPicture Objekt
  Public Property Get IconPicture(ByVal lHDC As Long, ByVal vlngIconIndex As Long, ByVal vlngImageIndex As Long) As StdPicture
   Dim hIcon As Long
   
    hIcon = IconHandle(lHDC, vlngIconIndex, vlngImageIndex)
  ' ndern des Icons in einenn VB StdPicture Objekt
    If (hIcon <> 0) Then
      Set IconPicture = IconToPicture(hIcon)
    End If
  End Property
' ========================================================

' ++ ffnet die Datei von der Modulebene Dateinamenvariable ++
  Private Function OpenFile(ByVal ofstrFilename As String, ByVal opmMode As OpenMode) As Long
   Dim lngHandle   As Long
    If (opmMode = OpenMode.ForReading) Then
        lngHandle = CreateFile(ofstrFilename, GENERIC_READ, FILE_SHARE_READ, ByVal CLng(0), _
                               OPEN_EXISTING, FILE_ATTRIBUTE_ARCHIVE, 0)
    Else
        lngHandle = CreateFile(ofstrFilename, GENERIC_WRITE, 0, 0, _
                            CREATE_ALWAYS, FILE_ATTRIBUTE_ARCHIVE, 0)
    End If

    OpenFile = lngHandle
  End Function

' Gibt die Breite einer Reihe in einem DIB Bitmap in Bits zurck.
  Private Function WidthBytes(ByVal wblngWidth As Long) As Long
   WidthBytes = ((wblngWidth + 31) \ 32) * 4
  End Function

' ffnet die ICL Bibliothekdatei und importiert dort alle Ikondaten.
  Public Sub ReadLibrary()
   Dim udtDosStub          As IMAGE_DOS_HEADER
   Dim udtNEHeader         As IMAGE_WINDOWS_NE_HEADER
   Dim udtIconGroupData    As IconGroupData
   Dim udtMemIcon          As MEMICONDIRENTRY
   Dim udtIconDir          As ICONDIR
   Dim udtBitmap           As IconBitmapData
   Dim lngFileHandle       As Long
   Dim lngStartOffset      As Long
   Dim lngBytesRead        As Long
   Dim lngAlignShift       As Long
   Dim lngOffset           As Long
   Dim lngTypeID           As Long
   Dim lngResCount         As Long
   Dim lngCounter          As Long
   Dim lng2ndCounter       As Long
   Dim lngTemp             As Long
   Dim lngColors           As Long
   Dim audtIconInfo()      As TNAMEINFO
   Dim audtIconGroupInfo() As TNAMEINFO
   Dim audtIconGroupData() As IconGroupData
   Dim astrNames()         As String
   Dim abytData()          As Byte
   Dim audtBitmaps()       As IconBitmapData
   Dim lngLength           As Long
   Dim lngBitmapLength     As Long

    lngFileHandle = OpenFile(strFileName, OpenMode.ForReading)
    
  ' Lesen im DOS Stup und zum Start von Windows (NE) Kopfsprung springen
    Call SetFilePointer(lngFileHandle, 0, 0, FILE_BEGIN)
    Call ReadFile(lngFileHandle, VarPtr(udtDosStub), Len(udtDosStub), lngBytesRead, ByVal 0&)
    lngStartOffset = udtDosStub.e_lfanew
    Call SetFilePointer(lngFileHandle, lngStartOffset, 0, FILE_BEGIN)
       
  ' Im Windows (NE) Kopfsprung lesen
    Call ReadFile(lngFileHandle, VarPtr(udtNEHeader), Len(udtNEHeader), lngBytesRead, ByVal 0&)
    
  ' Zum Ressourcentabelle bewegen
    Call SetFilePointer(lngFileHandle, lngStartOffset + udtNEHeader.ResourceTableOffset, 0, FILE_BEGIN)
        
    'Anfangen die Tabelle zu lesen
    ' rscAlignShift
    Call ReadFile(lngFileHandle, VarPtr(lngAlignShift), 2, lngBytesRead, ByVal 0&)
    lngAlignShift = 2 ^ lngAlignShift
    
  ' rscTypes
    Do
      ' rtTypeID
        Call ReadFile(lngFileHandle, VarPtr(lngTypeID), 2, lngBytesRead, ByVal 0&)
        If (lngTypeID <= 0) Then Exit Do
        If (lngTypeID > RT_HIGHORDER) Then
            lngTypeID = lngTypeID - RT_HIGHORDER
        End If
        
      'rtResourceCount
        Call ReadFile(lngFileHandle, VarPtr(lngResCount), 2, lngBytesRead, ByVal 0&)
        
      'rtReserved
        Call ReadFile(lngFileHandle, VarPtr(lngTemp), 4, lngBytesRead, ByVal 0&)

      'rtNameInfo
        Select Case lngTypeID
        
            Case RT_GROUP_ICON
                ReDim audtIconGroupInfo(lngResCount - 1)
                ReDim audtIconGroupData(lngResCount - 1)
                Call ReadFile(lngFileHandle, VarPtr(audtIconGroupInfo(0)), Len(audtIconGroupInfo(0)) * lngResCount, lngBytesRead, ByVal 0&)
                        
            Case RT_ICON
                ReDim audtIconInfo(lngResCount - 1)
                ReDim audtBitmaps(lngResCount - 1)
                Call ReadFile(lngFileHandle, VarPtr(audtIconInfo(0)), Len(audtIconInfo(0)) * lngResCount, lngBytesRead, ByVal 0&)
                
        End Select

    Loop Until lngTypeID <= 0
    
    lngCounter = -1
    
  ' rscResourceNames
    Do
        Call ReadFile(lngFileHandle, VarPtr(lngLength), 1, lngBytesRead, ByVal 0&)
        
        If (lngLength <= 0) Then Exit Do
        
        ReDim abytData(lngLength - 1)
        Call ReadFile(lngFileHandle, VarPtr(abytData(0)), lngLength, lngBytesRead, ByVal 0&)
        
        lngCounter = lngCounter + 1
        ReDim Preserve astrNames(lngCounter)
        
        astrNames(lngCounter) = StrConv(abytData(), vbUnicode, 1033)
        
    Loop Until lngLength <= 0
    Erase abytData()
    
  ' Jetzt sind wir in den Ressourcendaten. In jeden Icon Gruppe Kopfsprung lesen.
    For lngCounter = 0 To UBound(audtIconGroupData())
    
        lngOffset = audtIconGroupInfo(lngCounter).rnOffset
        If (lngOffset < 0) Then
            lngOffset = lngOffset + 65536 ' UWORD
        End If
        lngOffset = lngOffset * lngAlignShift
       
        lngLength = audtIconGroupInfo(lngCounter).rnLength
        If (lngLength < 0) Then
            lngLength = lngLength + 65536 ' UWORD
        End If
        lngLength = lngLength * lngAlignShift
        
        Call SetFilePointer(lngFileHandle, lngOffset, 0, FILE_BEGIN)
        
        Call ReadFile(lngFileHandle, VarPtr(udtIconDir), Len(udtIconDir), lngBytesRead, ByVal 0&)
        audtIconGroupData(lngCounter).DirHeader = udtIconDir
        
        ReDim audtIconGroupData(lngCounter).Entries(udtIconDir.idCount - 1)
        For lng2ndCounter = 0 To udtIconDir.idCount - 1
            Call ReadFile(lngFileHandle, VarPtr(udtMemIcon), Len(udtMemIcon), lngBytesRead, ByVal 0&)
            audtIconGroupData(lngCounter).Entries(lng2ndCounter) = udtMemIcon
        Next
    Next
    
    'Jetzt werden die Daten von den Icons geladen
    For lngCounter = 0 To UBound(audtIconInfo())
        lngOffset = audtIconInfo(lngCounter).rnOffset
        
        If (lngOffset < 0) Then
            lngOffset = lngOffset + 65536 ' UWORD
        End If
        lngOffset = lngOffset * lngAlignShift
        
        lngBitmapLength = audtIconInfo(lngCounter).rnLength
        If (lngBitmapLength < 0) Then
            lngBitmapLength = lngBitmapLength + 65536 ' UWORD
        End If
        lngBitmapLength = lngBitmapLength * lngAlignShift
        
        Call SetFilePointer(lngFileHandle, lngOffset, 0, FILE_BEGIN)
        
        ' Bitmap Kopfsprung
        Call ReadFile(lngFileHandle, VarPtr(udtBitmap.Header), Len(udtBitmap.Header), lngBytesRead, ByVal 0&)
        lngBitmapLength = lngBitmapLength - Len(udtBitmap.Header)
        
        'Palette
        lngColors = GetColorCount(udtBitmap.Header.biBitCount)
        If (lngColors > 0) Then
            ReDim udtBitmap.Palette(lngColors - 1)
            Call ReadFile(lngFileHandle, VarPtr(udtBitmap.Palette(0)), Len(udtBitmap.Palette(0)) * lngColors, lngBytesRead, ByVal 0&)
            lngBitmapLength = lngBitmapLength - Len(udtBitmap.Palette(0)) * lngColors
        Else
            Erase udtBitmap.Palette()
        End If

        ' XOR Map (Farbkanal)
        lngLength = udtBitmap.Header.biHeight / 2 * WidthBytes(udtBitmap.Header.biWidth * udtBitmap.Header.biBitCount * udtBitmap.Header.biPlanes)
        ReDim udtBitmap.XORMap(lngLength - 1)
        Call ReadFile(lngFileHandle, VarPtr(udtBitmap.XORMap(0)), lngLength, lngBytesRead, ByVal 0&)
        lngBitmapLength = lngBitmapLength - lngLength
            
        ' AND Map (Alphakanal)
        ReDim udtBitmap.ANDMap(lngBitmapLength - 1)
        Call ReadFile(lngFileHandle, VarPtr(udtBitmap.ANDMap(0)), lngBitmapLength, lngBytesRead, ByVal 0&)
        
        audtBitmaps(lngCounter) = udtBitmap
    Next
    
    Call FlushFileBuffers(lngFileHandle)
    Call CloseHandle(lngFileHandle)
    lngFileHandle = 0
    
  ' Alle Daten wurden geladen
  
    lngResCount = UBound(audtIconGroupData())
    ReDim icdIconData(lngResCount)
    For lngCounter = 0 To lngResCount
        With icdIconData(lngCounter)
            .Name = astrNames(lngCounter + 1)
            .Group = audtIconGroupData(lngCounter)
            ReDim .Bitmaps(.Group.DirHeader.idCount - 1)
            For lng2ndCounter = 0 To .Group.DirHeader.idCount - 1
                .Bitmaps(lng2ndCounter) = audtBitmaps(.Group.Entries(lng2ndCounter).nID - 1)
            Next
        End With
    Next
    
    lngIconCount = lngResCount + 1
  End Sub

' Gibt ein VB Bildobjekt zurck, das der angegebene Ikon enthlt.
  Private Function IconToPicture(ByVal hIcon As Long) As IPicture
   Dim objNewPic   As Picture
   Dim objPicConv  As PictDesc
   Dim udtGUID     As Guid

    objPicConv.cbSizeofStruct = Len(objPicConv)
    objPicConv.picType = vbPicTypeIcon
    objPicConv.hImage = hIcon
    
    With udtGUID
        .Data1 = &H7BF80980
        .Data2 = &HBF32
        .Data3 = &H101A
        .Data4(0) = &H8B
        .Data4(1) = &HBB
        .Data4(2) = &H0
        .Data4(3) = &HAA
        .Data4(4) = &H0
        .Data4(5) = &H30
        .Data4(6) = &HC
        .Data4(7) = &HAB
    End With
    Call OleCreatePictureIndirect(objPicConv, udtGUID, True, objNewPic)
    
    Set IconToPicture = objNewPic
  End Function
  
' Gibt ein Icon Handle zurck
  Private Function IconHandle(ByVal lHDC As Long, ByVal vlngIconIndex As Long, ByVal vlngImageIndex As Long) As Long
   Dim udtIconInfo As ICONINFO

  ' Erstellt ein Icon undirekt von den Bits
    udtIconInfo.fIcon = IMAGE_ICON
    udtIconInfo.hbmColor = GetIconBitmap(lHDC, vlngIconIndex, vlngImageIndex, ECFIImageConstants.ecfiImage, False, bReturnBmp:=True)
    udtIconInfo.hBmMask = GetIconBitmap(lHDC, vlngIconIndex, vlngImageIndex, ECFIImageConstants.ecfiMask, False, bReturnBmp:=True)
    
    IconHandle = CreateIconIndirect(udtIconInfo)
  End Function

  Private Function GetIconBitmap(ByVal lHDC As Long, ByVal vlngIconIndex As Long, ByVal vlngImageIndex As Long, _
                               ByVal eType As ECFIImageConstants, Optional ByVal bDrawToDC As Boolean = True, _
                               Optional ByVal X As Long, Optional ByVal Y As Long, _
                               Optional ByVal lWidth As Long, Optional ByVal lHeight As Long, _
                               Optional ByVal eOp As VBRUN.RasterOpConstants, _
                               Optional ByVal bReturnBmp As Boolean = False) As Long

   Dim udtBMIMono  As BITMAPINFO_1BPP
   Dim udtBMIXP    As BITMAPINFO_8BPP
   Dim udtIconData As IconData
   Dim udtMemEntry As MEMICONDIRENTRY
   Dim udtBitmap   As IconBitmapData
   Dim hDC         As Long
   Dim lngRC       As Long
   Dim hBmp        As Long
   Dim hBmpOld     As Long
   Dim abytData()  As Byte
   Dim lngLength   As Long
   
    udtIconData = icdIconData(vlngIconIndex - 1)

    udtMemEntry = udtIconData.Group.Entries(vlngImageIndex - 1)
    udtBitmap = udtIconData.Bitmaps(vlngImageIndex - 1)
    
  ' Gibt zurck oder zeichnet ein device abhngiges Bitmap,
  ' das die Abbildung (XOR) oder Maske(AND) enthlt
    If (eType = ECFIImageConstants.ecfiImage) Then
      ' Den XOR (Farbe) Teil vom Icon Bild extrahieren
   
      ' Zuerst eine kompatibles DC erstellen
        hDC = CreateCompatibleDC(lHDC)
        If (hDC <> 0) Then
          ' Erstellen eines Bitmap kompatibel mit den device
            hBmp = CreateCompatibleBitmap(lHDC, udtMemEntry.bWidth, udtMemEntry.bHeight)
            If (hBmp <> 0) Then
              ' Den Objekt im DC auwhlen
                hBmpOld = SelectObject(hDC, hBmp)
                If (hBmpOld <> 0) Then
                  ' Icon hat 2 x die richtige Hhen, so wird die BitmapInfoHeader
                  ' Struktur korrigiert, whrend das Bitmap erstellt wird
                    udtBitmap.Header.biHeight = udtBitmap.Header.biHeight \ 2
                   
                  ' Kippen der Bitmap-Information in einen Byte-array bei verwendendung von SetDIBitsToDevice
                    If (GetColorCount(udtBitmap.Header.biBitCount) > 0) Then
                        lngLength = ((UBound(udtBitmap.Palette()) + 1) * 4) + BITMAP_HEADER_SIZE
                        ReDim abytData(lngLength - 1)
                        Call CopyMemory(abytData(0), udtBitmap, lngLength)
                        Call CopyMemory(abytData(BITMAP_HEADER_SIZE), udtBitmap.Palette(0), lngLength - BITMAP_HEADER_SIZE)
                    Else
                        lngLength = BITMAP_HEADER_SIZE
                        ReDim abytData(lngLength - 1)
                        Call CopyMemory(abytData(0), udtBitmap, lngLength)
                    End If
                    
                    lngRC = SetDIBitsToDevice(hDC, 0, 0, udtMemEntry.bWidth, udtMemEntry.bHeight, _
                                              0, 0, 0, udtMemEntry.bHeight, udtBitmap.XORMap(0), _
                                              abytData(0), DIB_RGB_COLORS)
                    
                  ' Zeichnen, wenn erforderlich
                    If (bDrawToDC) Then
                        If (lWidth = 0) And (lHeight = 0) Then
                            Call BitBlt(lHDC, X, Y, udtMemEntry.bWidth, udtMemEntry.bHeight, hDC, 0, 0, eOp)
                        Else
                          ' NB nur einer greren Version erlauben, hier gezeichnet zu werden
                            If (lWidth = 0) Then
                                lWidth = udtMemEntry.bWidth
                            End If
                            If (lHeight = 0) Then
                                lHeight = udtMemEntry.bHeight
                            End If
                            Call StretchBlt(lHDC, X, Y, lWidth, lHeight, hDC, 0, 0, udtMemEntry.bWidth, udtMemEntry.bHeight, eOp)
                        End If
                    End If
                   
                  ' 2x die Ikonhhe hinzufgen
                    udtBitmap.Header.biHeight = udtBitmap.Header.biHeight * 2
                    
                  ' Entfernen des Bitmap aus dem DC
                    Call SelectObject(hDC, hBmpOld)
                End If
                
                If (bReturnBmp) Then
                   GetIconBitmap = hBmp
                Else
                   Call DeleteObject(hBmp)
                End If
            End If
             
          ' Lchen vom Memory DC
            Call DeleteDC(hDC)
        End If
       
    ElseIf (ECFIImageConstants.ecfiMask) Then
      ' Den AND(Maske) Teil vom Icon Bild extrahieren
        hDC = CreateCompatibleDC(0&)

      ' Erstellen einer Monochrom DC
        hDC = CreateCompatibleDC(0&)
        If (hDC <> 0) Then
          ' Erstellen einer Bitmap
            hBmp = CreateBitmap(udtMemEntry.bWidth, udtMemEntry.bHeight, 1, 1, ByVal 0&) ' rda002
            
            If (hBmp <> 0) Then
              ' Den mono-bitmap selektieren in ter DC
                hBmpOld = SelectObject(hDC, hBmp)
                If (hBmpOld <> 0) Then

                  ' Eine BitmapInfo Struktur erstellen,
                  ' die eine monochrome Version der in der Ikone gelieferten ist
                    With udtBMIMono
                        With .bmiHeader
                          ' In Icons die Hhe = 2x tatschliche Hhe
                            .biHeight = udtBitmap.Header.biHeight \ 2
                            .biWidth = udtBitmap.Header.biWidth
                            .biSize = udtBitmap.Header.biSize
                            .biPlanes = 1
                            .biBitCount = 1
                            .biCompression = BI_RGB
                            .biSizeImage = 0
                            .biXPelsPerMeter = 0
                            .biYPelsPerMeter = 0
                            .biClrUsed = 0
                            .biClrImportant = 0
                        End With
                      ' Eine monochrome Farbpalette aufstellen
                        With .bmiColors(0)
                            .rgbRed = 0
                            .rgbGreen = 0
                            .rgbBlue = 0
                            .rgbReserved = 0
                        End With
                        With .bmiColors(1)
                            .rgbRed = 255
                            .rgbGreen = 255
                            .rgbBlue = 255
                            .rgbReserved = 0
                        End With
                    End With
                    
                  ' Das kompatible Bitmap auf die Maskenstcke Stellen  im DIB innerhalb des Icons
                    lngRC = SetDIBitsToDevice(hDC, 0, 0, udtMemEntry.bWidth, udtMemEntry.bHeight, _
                                              0, 0, 0, udtMemEntry.bHeight, udtBitmap.ANDMap(0), _
                                              udtBMIMono, DIB_RGB_COLORS)
                    
                  ' Zeichnen, wenn erforderlich
                    If (bDrawToDC) Then
                        If (lWidth = 0) And (lHeight = 0) Then
                            Call BitBlt(lHDC, X, Y, udtMemEntry.bWidth, udtMemEntry.bHeight, hDC, 0, 0, eOp)
                        Else
                          ' NB nur einer greren Version erlauben, hier gezeichnet zu werden
                            If (lWidth = 0) Then
                                lWidth = udtMemEntry.bWidth
                            End If
                            If (lHeight = 0) Then
                                lHeight = udtMemEntry.bHeight
                            End If
                            Call StretchBlt(lHDC, X, Y, lWidth, lHeight, hDC, 0, 0, udtMemEntry.bWidth, udtMemEntry.bHeight, eOp)
                        End If
                    End If
                                 
                  ' Entfernen des Bitmap aus dem DC
                    Call SelectObject(hDC, hBmpOld)
                End If
              ' Lschen des Bitmaps, wenn erforderlich
                If (bReturnBmp) Then
                    GetIconBitmap = hBmp
                Else
                    Call DeleteObject(hBmp)
                End If
            End If
          ' Lchen der Memory DC
            Call DeleteObject(hDC)
        End If
    End If
End Function

Private Function GetColorCount(ByVal vlngBitCount As Long) As Long
    Select Case vlngBitCount
        Case 1:     GetColorCount = 2
        Case 4:     GetColorCount = 16
        Case 8:     GetColorCount = 256
        Case Else:  GetColorCount = 0
    End Select
End Function
